Attribute VB_Name = "m_SSConverter"
'
'    . v.1
'  (c)  , 2017
'
Option Explicit
Public sStatus As String
                                   
Private Type Alphabet
  az As String                                        '
  wt As String                                        '   ";"
  zero As Integer                                     '   ,  
  len As Integer                                      '   
  p As String * 1                                     ' 
  m As String * 1                                     ' 
End Type

Public Function Convert(sNumS As String, ParamS As String, ParamD As String) As String
'  
  'sNumS     -  
  Convert = ConvertDecToY(ConvertXToDec(sNumS, ParamS), ParamD)

''  'sysS      -    _
''                 0 -    _
''                 1/-1 - /-  _
''                 '+ -  ,  135(+) = 9(10) _
''                 R -  _
''                 xCy -  (, -: 2C10) _
''                 f - ""    _
''              +/-n - -   . A.8(16)=10.5(0)
''  'sysD      -    _
''                 0 -    _
''                 1/-1 - /-  _
''                 R -   _
''                 xCy -   ( BCD, 2C10, -516) _
''                 f - .      
End Function

Public Function ConvertDecToY(NumD As Double, ParamD As String) As String
  Dim abc As Alphabet
  Dim sys As String
  ParamToVar ParamD, sys, abc
  ConvertDecToY = SS_10toY(NumD, sys, abc)
End Function

Public Function ConvertXToDec(sNum As String, ParamS As String) As String
  Dim abc As Alphabet
  Dim sys As String
  ParamToVar ParamS, sys, abc
  ConvertXToDec = SS_Xto10(sNum, sys, abc)
End Function

Private Sub ParamToVar(sParam As String, sys As String, abc As Alphabet)
'    
  Dim ss() As String
  Dim s As String
  Dim i As Integer
  Dim j As Integer
  
  '  
  ss = Split(sParam, vbNewLine)
  For i = 0 To UBound(ss)
    j = InStr(2, ss(i), "=")
    If j > 0 Then
      s = Mid$(ss(i), j + 1)
      Select Case Left$(ss(i), 1)
        Case "s": sys = ReplaceSymb(s)                'System
        Case "a": abc.az = s                          'Alphabet
        Case "w": abc.wt = s                          'Weight
        Case "l": abc.len = CInt(Val(s))              'Len
        Case "z": abc.zero = CInt(Val(s))             'Zero
        Case "p": abc.p = s                           'Point
        Case "m": abc.m = s                           'Minus
      End Select
    End If
  Next i
  
  '     -
  If Len(sys) = 0 Then sys = "0"                      ' 
  If sys = "R" Then                                   '  ...
    If Len(abc.az) = 0 Or Len(abc.wt) = 0 Then        '      - 
      abc.az = "NSIVXLCDM"
      abc.wt = "0;.08333333;.5;1;5;10;50;100;500;1000"
    End If
  End If
  If Len(abc.az) = 0 Then abc.az = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyzŨ!""#$%&'()*+/:;<=>?@[\]^_`{|}~" '  -       
  If abc.zero < 1 Then abc.zero = 1                   '  
  If abc.len < 1 Then abc.len = 1                     '  
  If Asc(abc.p) = 0 Then abc.p = "."                  '  
  If Asc(abc.m) = 0 Then abc.m = "-"                  '  
End Sub
Private Function ReplaceSymb(s As String) As String   '    
  Dim nnS() As String
  Dim nnD() As String
  Dim i As Integer
  
  nnS = Split("B;T;O;D;H;,;C", ";")
  nnD = Split("2;3;8;10;16;.;C", ";")
  For i = 0 To UBound(nnS)
    s = Replace$(s, nnS(i), nnD(i), , , vbTextCompare)
  Next i
  ReplaceSymb = s
End Function


Function SS_XtoY(sNum As String, sysX As String, sysY As String, abcX As Alphabet, abcY As Alphabet) As String
  SS_XtoY = SS_10toY(SS_Xto10(sNum, sysX, abcX), sysY, abcY)
End Function

Function SS_10toY(NumD As Double, sysD As String, abc As Alphabet, Optional fSign As Boolean = False) As String
  Const iVR As Integer = 2                           '-  
  Const icMinR As Integer = -14                       '  (   )
  Dim sDst As String                                  '
  Dim iDst As Double                                  ' -  
  Dim iMaxC As Integer                                ' 
  Dim iMinC As Integer                                ' 
  Dim iCCount As Integer                              '- 
  Dim iMaxVR As Integer                               '     
  Dim iMaxR As Integer                                '     
  Dim iMinR As Integer                                '    
  Dim mTrend As Integer                               '
  Dim mSign As Integer                                ' ()
  Dim nnR() As Integer                                '  
  Dim ssR() As String                                 '   -   
  Dim ssA() As String                                 '   -    
  Dim ssC() As String
  Dim p As Integer                                    '  ()
  Dim n As Double                                     '
  Dim i As Double                                     'temp
  Dim j As Double                                     'temp
'  Dim s As String                                    'temp
  Dim s0 As String                                    'temp
  Dim fNeg As Boolean

  On Error GoTo Er
  
  '
  sStatus = vbNullString
  n = NumD                                            '    
  iDst = Val(sysD)                                    '   
  
  If sysD = "0" Then                                  ' 
    sDst = Replace$(CStr(n), ",", abc.p)
  
  ElseIf sysD = "1" Or sysD = "-1" Then               '   -
    s0 = Digit2Symbols(0, abc)                        ' ,  
    For p = 1 To Abs(Fix(n))                          '   
      sDst = sDst + s0
    Next p
    sDst = sDst + Mid$(s0, 1, Abs(n - Fix(n)) * abc.len) '      (     )
    If n * iDst < 0 Then sDst = abc.m & sDst          '        -  
  
  ElseIf sysD = "R" Or sysD = "N" Then                '  ٨ ( )   
    If n = 0 Then                                     ' 
      sDst = Digit2Symbols(0, abc)                    '  
    Else                                              '  
      fNeg = (n < 0)                                  ' 
      n = n * Sgn(n)
      ExtRoman abc                                    '   ( )
      ssR = Split(abc.az, ";")                        '  
      ssA = Split(abc.wt, ";")                        '  
      i = Val(ssA(1))                                 '  ,  
      p = UBound(ssA)
      Do While n > i                                  '   
        j = Val(ssA(p))
        If j > 0 Then
          Do While j <= n                             '    
            sDst = sDst & ssR(p)                      '     
            n = n - j                                 '     
          Loop
        End If
        p = p - 1                                     '     
      Loop
    End If
    
'  ElseIf sysD = "r" Then                              '   ( wiki).  ,      .
'    Do While n <> 0
'      p = p + 1
'      iDst = 10
'      i = Fix(n / iDst)                               'n \ iDst   ' 
'      j = n - i * iDst                                'n Mod iDst '  
'      If j = 4 Or j = 9 Then
'        sDst = Mid$("IXCM", p, 1) + Mid$("VXLCDM", (p - 1) * 2 + (j + 1) / 5, 1) + sDst
'      ElseIf j < 4 Then
'        sDst = Mid$("IIIXXXCCCMMM", 1 + (p - 1) * 3, j) + sDst
'      Else '5..8
'        sDst = Mid$("VLD", p, 1) + Mid$("IIIXXXCCCMMM", 1 + (p - 1) * 3, j - 5) + sDst
'      End If
'      n = i
'    Loop
    
  ElseIf sysD = "f" Then                              ' .   -  2.        
    fNeg = (n < 0)                                    ' 
    n = n * Sgn(n)
    Do While n > 0
      p = p + 1
      i = Fix(n / 2)
      j = n - i * 2
      n = i
      If j > 0 Then sDst = Digit2Symbols(p, abc) + sDst
    Loop
  
  ElseIf InStr(1, sysD, "C", vbTextCompare) Then      '  (, BCD)
    Dim s As String
    Dim s1 As String
    Dim lS As Integer
    Dim nnW() As Single                               '  
    Dim iPoint As Integer
    i = InStr(1, sysD, "C", vbTextCompare)
    s = Mid$(sysD, i + 1)
    sysD = Left$(sysD, i - 1)
    i = Val(s)                                        '  (   iDst)
    If i = 0 Then i = 10                              '     -   
    If iDst = 0 Then iDst = 10                        '     -   
    iMaxR = Abs(RoundUp(CSng(Math.Log(Abs(i)) / Math.Log(Abs(iDst))))) '  .    
    s = SS_10toY(n, s, abc)                           '    
    fNeg = DelMinus(s, abc)                           ' 
    Str2WW s, nnW(), abc, iPoint                      '  
    lS = Len(s)                                       '  
    s0 = Digit2Symbols(0, abc)                        '  
    For p = 1 To lS / abc.len                         '   
      s1 = SS_10toY(CDbl(nnW(p)), sysD, abc, fSign) '   
      For j = Len(s1) + 1 To iMaxR * abc.len Step abc.len '  
        s1 = s0 + s1
      Next j
      sDst = sDst & s1
      If p = iPoint And p < lS Then sDst = sDst & abc.p '          -  
    Next p

  Else                                                ' "" 
    If n <> 0 Then                                    '   
      '   
      mTrend = IIf(Abs(iDst) < 1, -1, 1)              '      .       - 1,   - -1.
      iMaxR = RoundUp(Math.Log(Abs(n)) / Math.Log(Abs(iDst))) '    
      iMaxVR = iMaxR + iVR * mTrend                  '  -    (   )
      iMinR = icMinR * mTrend                         '    
      If fSign Then mSign = -1 Else mSign = 1         '   -   'And (n / iDst ^ iMaxR) < iMinC
      '     
      If iMinR < iMaxVR Then
        ReDim nnR(iMinR To iMaxVR) As Integer
      Else
        ReDim nnR(iMaxVR To iMinR) As Integer
      End If
      
      '
      For p = iMaxR To iMinR Step -mTrend             '    (>)
        i = iDst ^ p                                  '  
        nnR(p) = Fix(n / i)                           '   
        n = n - nnR(p) * i                            '     
        If fSign Then nnR(p) = nnR(p) * mSign         '    -    
        If n = 0 Then Exit For                        '   -  
      Next p
      
      '   
      p = Abs(RoundUp(iDst ^ mTrend))                 '- 
      If abc.zero > p Then abc.zero = p               '        - ,     .  . 
      iMaxC = p - abc.zero                            ' 
      iMinC = 1 - abc.zero                            ' 
      If PosInspect(nnR(), iDst, iMinC, iMaxC, iMaxR, iMaxVR, iMinR, mTrend) Then '  ( )   -  
        
        '  
        ReDim ssC(iMinC To iMaxC) As String           '    
        For p = iMinC To iMaxC                        '    
          ssC(p) = Digit2Symbols(p, abc)
        Next p
        If mSign < 0 Then sDst = abc.m                '   -   
        i = UBound(nnR)                               '  ( )  
        For p = i To 0 Step -1                        '      (>)
          If nnR(p) <> 0 Then Exit For
        Next p
        For p = p To 0 Step -1                        '      (>)
          sDst = sDst + ssC(nnR(p))
        Next p
        If Len(sDst) = 0 Then sDst = ssC(0)           '    -  
        For p = LBound(nnR) To -1                     '     (<)
          If nnR(p) <> 0 Then Exit For
        Next p
        For p = p To -1                               '       (<)
          If p >= i Then Exit For                     '    ( )  - 
          s0 = ssC(nnR(p)) + s0
        Next p
        For p = p To -1                               '  -1  
          s0 = ssC(0) + s0
        Next p
        If Len(s0) > 0 Then sDst = sDst & abc.p & s0  '    -    
      
      Else                                            '     
        If Not fSign Then
          sDst = SS_10toY(NumD, sysD, abc, True) ' ,    
        Else
          sStatus = "   SS_10toY"
          Exit Function
        End If
      End If

    Else
      sDst = Digit2Symbols(0, abc)                    '  -   
    End If
  
  End If                                              ' 
  If fNeg Then sDst = abc.m & sDst                    ' 
  SS_10toY = sDst
Exit Function
Er:
  sStatus = "  SS_10toY"
End Function

Private Function PosInspect(nnR() As Integer, nSys As Double, iMinC As Integer, iMaxC As Integer, iMaxR As Integer, iMaxVR As Integer, iMinR As Integer, mTrend As Integer) As Boolean
'  :       
'nnR()  -   .  .    
'nSys   -  
'iMinC  -   
'iMaxC  -   
'iMaxR  -      
'iMaxVR -     
'iMinR  -     
'mTrend -     
  Dim p As Integer
  Dim lLoop As Long
  Dim bErr As Boolean
  For p = iMaxR To iMinR Step -mTrend                 '   .     
    If p * mTrend < iMaxVR * mTrend And lLoop < 10000 Then '             
      lLoop = lLoop + 1
      If nnR(p) < iMinC Then                          '   
        PosCorrection nnR, nSys, p, iMinC, iMinR, mTrend '  
      ElseIf nnR(p) > iMaxC Then                      '   
        PosCorrection nnR, nSys, p, iMaxC, iMinR, mTrend
      End If
    Else                                              '     ( )    
      bErr = True
      Exit For
    End If
  Next p
  PosInspect = Not bErr
End Function

Private Sub PosCorrection(nnR() As Integer, nSys As Double, iR As Integer, xBound As Integer, iMinR As Integer, mTrend As Integer)
'  :             
'nnR()  -   .  .    
'nSys   -  
'iR     -  ,     
'xBound - ,     (   )
'iMinR  -     
'mTrend -     
  Dim n As Double                                     'temp
  Dim n1 As Double                                    'temp
  Dim i As Integer                                    '  
  n = RoundUp((xBound - nnR(iR)) / nSys ^ mTrend)     '         ( )
  nnR(iR + mTrend) = nnR(iR + mTrend) - n             '  ,       
  For i = iR To iMinR Step -mTrend                    '        
    n = n * nSys ^ mTrend                             '       (,    ,         )
    n1 = Fix(n)                                       '   
    nnR(i) = nnR(i) + n1                              ' 
    n = n - n1                                        '  
    If n = 0 Then Exit For                            '   - 
  Next i
  iR = iR + mTrend * 2                                '     , ..   .  2 ,   .
End Sub

'=================================================================================================================================================
'=================================================================================================================================================


Function SS_Xto10(sNumS As String, sysS As String, abc As Alphabet) As Double
  Dim nnR() As Single                                 '  
  Dim iSrc As Single
  Dim i As Double
  Dim iPoint As Integer                               ' 
  Dim lS As Integer                                   '  
  Dim n As Double
  Dim n1 As Double
  Dim p As Integer
  Dim fNeg As Boolean
  Dim fNeg1 As Boolean
  Dim s As String
  Dim iMaxR As Integer
  
  On Error GoTo Er

  sStatus = vbNullString
  
  If Len(sNumS) > 0 Then
    iSrc = Val(sysS)                                  ' 
    fNeg = DelMinus(sNumS, abc)
    lS = Len(sNumS)                                   '   
    
    If sysS = "0" Then                                ' 
      n = Val(sNumS)
    
    ElseIf sysS = "1" Or sysS = "-1" Then             '   -
      n = lS / abc.len * iSrc                         ' -        
    
    ElseIf sysS = "N" Then                            '  (   )
      Str2WW sNumS, nnR(), abc, iPoint
      For i = 1 To Len(sNumS)                         '   
        n = n + nnR(i)
      Next i
    
    ElseIf sysS = "R" Then                            ' 
      Str2WW sNumS, nnR(), abc, iPoint                '      
      For p = 1 To Len(sNumS)                         '   
        If p < lS Then                                '    - ,  
          If nnR(p) < nnR(p + 1) Then nnR(p) = -nnR(p) '      -   
        End If
        n = n + nnR(p)
      Next p
    
    ElseIf InStr(1, sysS, "C", vbBinaryCompare) Then  '   (BCD  )
      Dim a As Alphabet
      Dim s1 As String
      a = abc
      a.len = 1
      i = InStr(1, sysS, "C", vbBinaryCompare)
      s1 = Mid$(sysS, i + 1)                          ' 
      sysS = Left$(sysS, i - 1)                       ' 
      i = Val(s1)                                     '  (    iSrc)
      If i = 0 Then i = 10
      If iSrc = 0 Then iSrc = 10                      '    -   
      iMaxR = Abs(RoundUp(CSng(Math.Log(Abs(i)) / Math.Log(Abs(iSrc))))) ' ,        
      For p = 1 To Len(sNumS) Step iMaxR * abc.len    '     
        i = InStr(1, Mid$(sNumS, p, iMaxR * abc.len), abc.p) '   ?
        If i > 0 Then                                 '  
          If i = 1 Then                               '    
            s = s & abc.p                             '   
            p = p + 1                                 '  
            i = 0                                     '   
          Else
            i = 1                                     '   
          End If
        End If
        s = s + SS_XtoY(Mid$(sNumS, p, iMaxR * abc.len + i), sysS, s1, abc, a) '   .  .  
        p = p + i
      Next p
      n = SS_Xto10(s, s1, a)                          '     
    
    ElseIf sysS = "f" Then                            ' .   -  2.   .
      Str2WW sNumS, nnR(), abc, iPoint
      For i = 1 To Len(sNumS)                         '   
        n = n + 2 ^ nnR(i)
      Next i
    
    Else                                              ' "" 
      Str2WW sNumS, nnR(), abc, iPoint
      '  ( ).   ( 11%)
      For p = 1 To iPoint                             '   (>)
        n = n * iSrc + nnR(p)
      Next p
      For p = Len(sNumS) / abc.len To iPoint + 1 Step -1 '   (<)
        n1 = (n1 + nnR(p)) / iSrc
      Next p
      n = n + n1                                      '    
  ''   '  ( )
  ''    For p = 1 To Len(sNumS) / abc.len               '   
  ''      n = n + nnR(p) * (iSrc ^ (i - p))
  ''    Next p
    
    End If
  Else
    n = 0
  End If
  
  If fNeg Then n = -n
  SS_Xto10 = n
Exit Function
Er:
  sStatus = "  SS_Xto10"
End Function


Private Function RoundUp(c As Variant) As Integer
  RoundUp = Fix(c + Sgn(c - Fix(c)))
End Function

Private Function DelMinus(sNum As String, abc As Alphabet) As Boolean
  '  
  DelMinus = (Left$(sNum, 1) = abc.m)                 '         
  If DelMinus Then sNum = Mid$(sNum, 2)               '     -  
End Function

Private Function Digit2Symbols(i As Integer, abc As Alphabet) As String
  '   ,   
  Digit2Symbols = Mid$(abc.az, (i + abc.zero - 1) * abc.len + 1, abc.len)
End Function

Private Sub Str2WW(sNum As String, nnR() As Single, abc As Alphabet, iPoint As Integer)
  '       ( 1  - )
  'sNum       - ,   - aabbcc.dd
  'nnR()      -    1  -      
  'abc        -  ()
  'iPoint     -    (-     )
  Dim s As String                                     '  
  Dim k As Integer                                    '    
  Dim i As Integer                                    '     
  Dim azW() As String
  ReDim nnR(1 To Len(sNum) / abc.len) As Single       '    
  iPoint = -2                                         '  -   -     
  i = 1                                               '     
  Do While i * abc.len <= Len(sNum)                   '      
    s = Mid$(sNum, (i - 1) * abc.len + 1, abc.len)    '   -   
    k = 0                                             '     
    Do
      k = InStr(k + 1, abc.az, s, vbBinaryCompare)    '    
    Loop Until (k - 1) / abc.len = Fix((k - 1) / abc.len) Or k = 0 '            
    If k > 0 Then                                     '    ...
      nnR(i) = (k + abc.len - 1) / abc.len - abc.zero '   ( )  .        
      i = i + 1                                       '  
    Else                                              '    ...
      If Left$(s, 1) = abc.p Then s = abc.p: iPoint = i - 1 '   -        
      sNum = Replace$(sNum, s, vbNullString, , , vbBinaryCompare) '       
    End If
  Loop
  If iPoint < 0 Then iPoint = i - 1                   '    -   
  '  (  )
  If Len(abc.wt) > 0 Then                             '    -     
    azW = Split(abc.wt, ";")
    For i = 1 To i - 1
      nnR(i) = Val(azW(nnR(i) + abc.zero - 1))
    Next i
  End If
End Sub

Public Sub ExtRoman(abc As Alphabet)
'      (    )
'    ,   (  ,     )
  Dim ssA() As String
  Dim sR As String
  Dim sA As String
  Dim i As Integer
  Dim j As Integer
  Dim n As Single
  ssA = Split(abc.wt, ";")
  For i = Len(abc.az) To 1 Step -1                    '   
    sR = ";" & Mid$(abc.az, i, 1) & sR                ' ""  ...
    sA = ";" & ssA(i - 1) & sA                        '  
    If Val(ssA(i - 1)) <> 0 Then                      '   
      For j = 1 To i - 1                              ' 
        n = Val(ssA(j - 1))                           '"" 
        If n <> 0 Then                                '    
          n = Val(ssA(i - 1)) - n                     '     
          If n > Val(ssA(i - 2)) Then                 '     - 
            sR = ";" & Mid$(abc.az, j, 1) & Mid$(abc.az, i, 1) & sR
            sA = ";" & CStr(n) & sA
          End If
        End If
      Next j
    End If
  Next i
  abc.az = Mid$(sR, 2)                                '  
  abc.wt = Replace$(Mid$(sA, 2), ",", ".", , , vbBinaryCompare) '  
End Sub
